Index: wsdl/fedd.wsdl
===================================================================
--- wsdl/fedd.wsdl	(revision 2761484680c5609adfc4d1acb82a927b3f339e07)
+++ wsdl/fedd.wsdl	(revision 175b444be538c90b2bbb8eded4663576c1f26ad7)
@@ -1,15 +1,15 @@
 <?xml version="1.0"?>
 <definitions name="fedd"
-  targetNamespace="http://www.isi.edu/faber/fedd.wsdl"
-  xmlns:tns="http://www.isi.edu/faber/fedd.wsdl"
-  xmlns:xsd1="http://www.isi.edu/faber/fedd_types"
-  xmlns:topdl="http://www.isi.edu/faber/topdl"
+  targetNamespace="http://www.isi.edu/fedd.wsdl"
+  xmlns:tns="http://www.isi.edu/fedd.wsdl"
+  xmlns:xsd1="http://www.isi.edu/fedd_types"
+  xmlns:topdl="http://www.isi.edu/topdl"
   xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"
   xmlns="http://schemas.xmlsoap.org/wsdl/">
 
-   <import namespace="http://www.isi.edu/faber/fedd_types" 
+   <import namespace="http://www.isi.edu/fedd_types" 
      location="fedd_types.xsd"/>
 
-   <import namespace="http://www.isi.edu/faber/topdl" 
+   <import namespace="http://www.isi.edu/topdl" 
          location="topdl.xsd"/>
   <!--
@@ -275,15 +275,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:RequestAccessRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:RequestAccessResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="RequestAccessFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -296,15 +296,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:ReleaseAccessRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:ReleaseAccessResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="ReleaseAccessFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -317,15 +317,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:NewRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:NewResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="NewFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -338,15 +338,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:CreateRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:CreateResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="CreateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -359,15 +359,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:VtopoRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:VtopoResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="VtopoFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -381,15 +381,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:VisRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:VisResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="VisFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -402,15 +402,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:InfoRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:InfoResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="InfoFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -423,15 +423,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:MultiInfoRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:MultiInfoResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="MultiInfoFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -444,15 +444,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:TerminateRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:TerminateResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="TerminateFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -465,15 +465,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:StartSegmentRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:StartSegmentResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="StartSegmentFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -486,15 +486,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:TerminateSegmentRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:TerminateSegmentResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="TerminateSegmentFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -507,15 +507,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:SetValueRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:SetValueResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="SetValueFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -528,15 +528,15 @@
 	<input>
 	  <soap:body use="literal" parts="tns:GetValueRequestBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</input>
 	<output>
 	  <soap:body use="literal" parts="tns:GetValueResponseBody"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</output>
 	<fault name="GetValueFeddFault">
 	  <soap:fault use="literal"  name="tns:FeddFault"
-	    namespace="http://www.isi.edu/faber/fedd.wsdl"
+	    namespace="http://www.isi.edu/fedd.wsdl"
 	    encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>
 	</fault>
@@ -549,5 +549,5 @@
       </documentation>
       <port name="feddPort" binding="tns:feddBinding">
-	<soap:address location="http://www.isi.edu/faber/fedd"/>
+	<soap:address location="http://www.isi.edu/fedd"/>
       </port>
     </service>